<?php

/**
 * rel_interfaz actions.
 *
 * @package    Sofhouse
 * @subpackage rel_interfaz
 * @author     Software House
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class rel_interfazActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */

            $whereCia = ' ';
            if (isset($request['id_cia'])) {
                $whereCia = " AND tab0.id_cia = '" . $request['id_cia'] . "' ";
            }

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
 
    select 
    tab1.id_interfaz, tab0.id_interfaz_padre, tab1.nombre, tab1.descripcion, tab0.condicion, tab0.estado, tab1.condicion as condicion_inter
    from cni_rel_interfaz tab0 
    join cni_interfaz tab1 on tab0.id_interfaz_hijo=tab1.id_interfaz and tab0.id_cia=tab1.id_cia
    where 1=1  $whereCia
            
    ORDER BY id_interfaz_padre    
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
   select 
    tab1.id_interfaz, tab0.id_interfaz_padre, tab1.nombre, tab1.descripcion, tab0.condicion, tab0.estado, tab1.condicion as condicion_inter
    from cni_rel_interfaz tab0 
    join cni_interfaz tab1 on tab0.id_interfaz_hijo=tab1.id_interfaz and tab0.id_cia=tab1.id_cia
    where 1=1  $whereCia
            
    ORDER BY id_interfaz_padre        
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('cni_rel_interfaz');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                  //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[REL_INTERFAZ] Consulta exitosa.");
            } else {

                $mensaje = "[REL_INTERFAZ] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error="[REL_INTERFAZ] ERROR: ". $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    public function executeAdd(sfWebRequest $request) {
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            
             $whereCia = ' ';
            if (isset($request['id_cia'])) {
                $whereCia = " AND tab0.id_cia = '" . $request['id_cia'] . "' ";
            }
            /*
             * variables de filtro
             */
            $accesoPadre = $request['id_interfaz_padre'];
            $accesoHijo = $request['id_interfaz_hijo'];
            $cia =  $request['id_cia'];
            $condicion =  $request['condicion'];
            $estado= $request['estado'];

            $sql = <<<EOD
            
INSERT INTO cni_rel_interfaz (id_interfaz_padre, id_interfaz_hijo, id_cia, condicion, estado) values ($accesoPadre, $accesoHijo, $cia, '$condicion', $estado)


EOD;

            //Insertar nuevos accesos
            CN_TABLE::executeSQL($sql);

            $this->logMessage("[REL_INTERFAZ-ADD] Registro Exitoso");

            $sql = <<<EOD
select count(*) as count from(

 
   select 
    tab1.id_interfaz, tab0.id_interfaz_padre, tab1.nombre, tab1.descripcion, tab0.condicion, tab0.estado
    from cni_rel_interfaz tab0 
    join cni_interfaz tab1 on tab0.id_interfaz_hijo=tab1.id_interfaz and tab0.id_cia=tab1.id_cia
    where 1=1  $whereCia
            
    ORDER BY id_interfaz_padre        
            
 
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {


                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
 
            
  select 
    tab1.id_interfaz, tab0.id_interfaz_padre, tab1.nombre, tab1.descripcion, tab0.condicion, tab0.estado
    from cni_rel_interfaz tab0 
    join cni_interfaz tab1 on tab0.id_interfaz_hijo=tab1.id_interfaz and tab0.id_cia=tab1.id_cia
    where 1=1  $whereCia
            
    ORDER BY id_interfaz_padre          
            
 
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;


                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo regsitra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 3;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_acceso_acceso');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                 //   $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }
             
                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[REL_INTERFAZ] Consulta exitosa.");
            } else {

                $mensaje = "[REL_INTERFAZ] No hay registros de consulta.";
                $this->status = 1;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {


            $this->logMessage("[REL_INTERFAZ-ADD] Registro Fallido $e");
            $this->status = 1;
            $this->list_data = array();
        }
    }

//    public function executeUpdate(sfWebRequest $request) {
//
//        //Revisar que sea post
//        //$this->forward404Unless($request->isMethod('post'));
//        //Guardar los parametros del request en el log
//        $this->logMessage("---BEGIN Logging request");
//        foreach ($request->getPostParameters() as $key => $value) {
//            $this->logMessage("request[$key] = $value");
//        }
//        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
//        foreach ($request->getGetParameters() as $key => $value) {
//            $this->logMessage("request[$key] = $value");
//        }
//        $this->logMessage("---END Logging request");
//
//        /*
//         * Manejo de errores
//         */
//        try {
//
//            /*
//             * Paginacion
//             */
//            if (isset($request['_startRow'])) {
//                $rowStart = $request['_startRow'];
//            } else {
//                $rowStart = 0;
//            }
//
//            if (isset($request['_endRow'])) {
//                $rowEnd = $request['_endRow'];
//            } else {
//                $rowEnd = 75;
//            }
//
//            /*
//             * variables de filtro
//             */
//
//            $whereModulo = ' ';
//            if (isset($request['id_modulo'])) {
//                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
//            }
//
//            $orden = "'" . $request['orden'] . "'";
//
//            $whereAccesoPadre = " and id_acceso_padre = '" . $request['id_acceso_padre'] . "' ";
//
//            $whereAccesoHijo = " and id_acceso_hijo = '" . $request['id_acceso'] . "' ";
//
//          
//            $sql = <<<EOD
//
//   UPDATE ca_acceso_acceso SET orden=$orden where 1=1 $whereAccesoPadre $whereAccesoHijo
//   
//EOD;
//
//            //ejecuta y obtiene el resultado del sql
//            $records = CN_TABLE::executeSQL($sql);
//            // Solo regsitra log la primera vez de consulta
//            if ($rowStart == 0) {
//                //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
//                $id_ope_bd = 2;
//                //obtener id maestro tabla
//                $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_acceso_acceso');
//                //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
//             //   $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
//            }
//
//            $this->status = 0;
//            $this->list_data = $records;
//            $this->logMessage("[ACCESOS_ACCESOS] Consulta Update exitosa.");
//        } catch (Exception $e) {
//
//            $this->status = 1;
//            $this->mensajeError = "ERROR UPDATE!!!";
//            $this->list_data = array();
//            $this->logMessage("ERROR UPDATE!!!");
//            $this->logMessage("Error: " . $e->getMessage());
//        }
//    }
//    
    
    public function executeRemove(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */

            $whereCia = ' ';
            if (isset($request['id_cia'])) {
                $whereCia = " AND tab0.id_cia = '" . $request['id_cia'] . "' ";
            }

            $whereAccesoPadre = " and id_acceso_padre = '" . $request['id_acceso_padre'] . "' ";

            $whereAccesoHijo = " and id_acceso_hijo = '" . $request['id_acceso'] . "' ";

            $sql = <<<EOD

   DELETE FROM ca_acceso_acceso where 1=1 $whereAccesoPadre $whereAccesoHijo  
   
EOD;

            CN_TABLE::executeSQL($sql);
            
            // Solo regsitra log la primera vez de consulta
            if ($rowStart == 0) {
                //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                $id_ope_bd = 2;
                //obtener id maestro tabla
                $id_mae_bd = CN_TABLE::consultarIdTablaBD('rel_interfaz');
                //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
            }

            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[REL_INTERFAZ] Consulta Remove exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR REMOVE!!!";
            $this->list_data = array();
            $this->logMessage("ERROR REMOVE!!!");
            $this->logMessage("Error: " . $e->getMessage());
        }
    }

    

}